'___________________________________________________

'                        D O   E N C R Y P T I O N

'                            Created 12/09/07

'___________________________________________________

'Make sure to add a reference to System.Configuration DLL

'This routine will encrypt/decrypt the connection string section of app.config. It puts a cipher in the .exe.config file
'in the \bin folder. The app.config can only be decrypted on the development machine!
'This sub just toggles the process as you run it. You pass it the name of the .exe file in your app.

'Updated 10/13/08

'   10/13/08 Added the encryption option to file menu and make it appear checked/unchecked. See below.

Imports System
Imports System.Configuration


Public Class DoEncryption

    Friend Shared msgTitle As String = "Encrypting Connection String"
    Friend Shared assemblyName As String = System.Reflection.Assembly.GetExecutingAssembly.GetName.Name & ".exe"

   


    Friend Shared Sub ConnStringEncryption()

     
        Try
            ' Open the configuration file and retrieve 
            ' the connectionStrings section.
            Dim config As Configuration = ConfigurationManager. _
                OpenExeConfiguration(assemblyName)

            Dim section As ConnectionStringsSection = DirectCast(config.GetSection("connectionStrings"), _
                ConnectionStringsSection)

            If section.SectionInformation.IsProtected Then
                ' Remove encryption.
                section.SectionInformation.UnprotectSection()
                MessageBox.Show("The 'bin\debug\ADO in Code.exe.config' file IS NOT protected", msgTitle, MessageBoxButtons.OK, MessageBoxIcon.Information)

                '---uncheck the menu item
                My.Forms.frmADO2.EncryptConnToolStripMenuItem.Checked = False

            Else
                ' Encrypt the section.
                section.SectionInformation.ProtectSection("DataProtectionConfigurationProvider")
                MessageBox.Show("The 'bin\debug\ADO in Code.exe.config' file IS protected.", msgTitle, MessageBoxButtons.OK, MessageBoxIcon.Information)

                '---show menu item checked
                My.Forms.frmADO2.EncryptConnToolStripMenuItem.Checked = True
            End If

            ' Save the current configuration.
            config.Save()

        Catch ex As Exception
            MessageBox.Show("An error occurred while encoding/decoding." & ex.Message, msgTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Friend Shared Sub EncryptOnHost()


        ' Open the configuration file and retrieve 
        ' the connectionStrings section.
        Dim config As Configuration = ConfigurationManager. _
            OpenExeConfiguration(assemblyName)

        Dim section As ConnectionStringsSection = DirectCast(config.GetSection("connectionStrings"), _
            ConnectionStringsSection)

        ' Encrypt the section.
        section.SectionInformation.ProtectSection("DataProtectionConfigurationProvider")


        ' Save the current configuration.
        config.Save()
    End Sub

End Class


